#ifndef GAMEENGINE_H
#define GAMEENGINE_H

#include <GL/glew.h>
#include <GLFW/glfw3.h>
#include <stdio.h>
#include <stdlib.h>

static const long NANOS_PER_TICK = 50000000;
static const int MAX_TICKS_PER_FRAME = 5;

typedef void (*InitFunction)(int);
typedef void (*TickFunction)(int);
typedef void (*RenderTickFunction)(int, float);
typedef void (*WindowResize)(int, int);
typedef void (*MouseMove)(float, float);

int startGame(char* name, InitFunction init, TickFunction tick, RenderTickFunction renderTick,
              WindowResize windowResize, MouseMove move);
GLuint getProgram();

#endif